- Main Page
- Related Pages
- Modules
- Classes
- Files

Functions
Geometric functions
GLM Core

## Functions
template<typename valType >
detail::tvec3< valType > | cross (detail::tvec3< valType > const &x, detail::tvec3< valType > const &y)
template<typename genType >
genType::value_type | distance (genType const &p0, genType const &p1)
template<typename genType >
genType::value_type | dot (genType const &x, genType const &y)
template<typename genType >
genType | faceforward (genType const &N, genType const &I, genType const &Nref)
template<typename genType >
genType::value_type | length (genType const &x)
template<typename genType >
genType | normalize (genType const &x)
template<typename genType >
genType | reflect (genType const &I, genType const &N)
template<typename genType >
genType | refract (genType const &I, genType const &N, typename genType::value_type const &eta)

## Detailed Description

These operate on vectors as vectors, not component-wise.

## Function Documentation

detail::tvec3<valType> glm::cross | ( | detail::tvec3< valType > const & | x,
|  | detail::tvec3< valType > const & | y
| ) |  |

Returns the cross product of x and y.

Template Parameters:

  valType | Floating-point scalar types.

See also:
  GLSL cross man page
  GLSL 4.20.8 specification, section 8.5 Geometric Functions

genType::value_type glm::distance | ( | genType const & | p0,
|  | genType const & | p1
| ) |  |

Returns the distance betwwen p0 and p1, i.e., length(p0 - p1).

Template Parameters:

  genType | Floating-point vector types.

See also:
  GLSL distance man page
  GLSL 4.20.8 specification, section 8.5 Geometric Functions

genType::value_type glm::dot | ( | genType const & | x,
|  | genType const & | y
| ) |  |

Returns the dot product of x and y, i.e., result = x * y.

Template Parameters:

  genType | Floating-point vector types.

See also:
  GLSL dot man page
  GLSL 4.20.8 specification, section 8.5 Geometric Functions

genType glm::faceforward | ( | genType const & | N,
|  | genType const & | I,
|  | genType const & | Nref
| ) |  |

If dot(Nref, I) < 0.0, return N, otherwise, return -N.

Template Parameters:

  genType | Floating-point vector types.

See also:
  GLSL faceforward man page
  GLSL 4.20.8 specification, section 8.5 Geometric Functions

genType::value_type glm::length | ( | genType const & | x | ) |

Returns the length of x, i.e., sqrt(x * x).

Template Parameters:

  genType | Floating-point vector types.

See also:
  GLSL length man page
  GLSL 4.20.8 specification, section 8.5 Geometric Functions

genType glm::normalize | ( | genType const & | x | ) |

Returns a vector in the same direction as x but with length of 1.

See also:
  GLSL normalize man page
  GLSL 4.20.8 specification, section 8.5 Geometric Functions

genType glm::reflect | ( | genType const & | I,
|  | genType const & | N
| ) |  |

For the incident vector I and surface orientation N, returns the reflection direction : result = I - 2.0 * dot(N, I) * N.

Template Parameters:

  genType | Floating-point vector types.

See also:
  GLSL reflect man page
  GLSL 4.20.8 specification, section 8.5 Geometric Functions

genType glm::refract | ( | genType const & | I,
|  | genType const & | N,
|  | typename genType::value_type const & | eta
| ) |  |

For the incident vector I and surface normal N, and the ratio of indices of refraction eta, return the refraction vector.

Template Parameters:

  genType | Floating-point vector types.

See also:
  GLSL refract man page
  GLSL 4.20.8 specification, section 8.5 Geometric Functions